
% create mapping screen

warning off

% get data field names and put them into a string array
names = fieldnames(data);nvars = length(names);
S=names{1};for i=2:nvars;S=[S '|' names{i}];end

figure('Name',['data file: ' data.fileName],'units','norm','pos',...
    [.23 .14 .65 .65],'Tag','mapfigure')
uimenu('Label','BROWSER:  mapping screen (fast version)','fore',[0 0 .8]);
uicontrol('Style','frame','Position',[0.01 0.12 .21 .30],...
    'back',get(gcf,'Color')*.9,'units','norm');
uicontrol('Style','frame','Position',[0.01 0.42 .21 .24],...
    'back',get(gcf,'Color')*.9,'units','norm');
uicontrol('Style','frame','Position',[0.01 0.66 .21 .08],...
    'back',get(gcf,'Color')*.9,'units','norm');

% variable list and label
varlist = uicontrol('Style','listbox','String',S,'pos',[0.015 .20 .20 .15],...
    'units','norm','back',[.85 .9 .85],'fore',[.2 .2 .2]);
uicontrol('Style','Text','String','variable list','FontWeight','b',...
    'FontSize',10,'pos',[.015 .35 .20 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color')*.9);
uicontrol('Style','Text','String','housekeeping data','FontWeight','b',...
    'FontSize',10,'pos',[.015 .37 .20 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color')*.9);
mapbutton1 = uicontrol('Style','PushButton','units','norm','pos',[.08 0.15 .06 .04],...
    'Callback','cflag=41;callback','back',[.8 0 0],'String','map',...
    'fore',[.85 .85 .85],'FontWeight','b');

% wavenumber limits for mapping spectral data
wnbr1a = uicontrol('Style','edit','String',num2str(min(data.wnum1)),'pos',[0.02 .52 .08 .04],...
    'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','wnbrs');
uicontrol('Style','Text','String','v1','FontWeight','b',...
    'FontSize',10,'pos',[.02 .56 .08 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color')*.9,'Tag','wnbrs');
wnbr2a = uicontrol('Style','edit','String',num2str(max(data.wnum1)),'pos',[0.11 .52 .08 .04],...
    'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','wnbrs');
uicontrol('Style','Text','String','v2','FontWeight','b',...
    'FontSize',10,'pos',[.11 .56 .08 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color')*.9,'Tag','wnbrs');
mapbutton2 = uicontrol('Style','PushButton','units','norm','pos',[.08 0.43 .06 .04],...
    'Callback','cflag=42;callback','back',[.8 0 0],'String','map',...
    'fore',[.85 .85 .85],'FontWeight','b');
uicontrol('Style','Text','String','spectral data','FontWeight','b',...
    'FontSize',10,'pos',[.02 .63 .18 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color')*.9);

% time limits
time2b = uicontrol('Style','edit','String',datestr(dn(max(data.nss1970))),'pos',[0.07 .67 .14 .03],...
    'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','time2b');
set(time2b,'ToolTipString','End time. Format must be DD-MMM-YYYY HH:MM:SS');
uicontrol('Style','Text','String','end','FontWeight','b',...
    'FontSize',10,'pos',[.02 .675 .05 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color')*.9);
time1b = uicontrol('Style','edit','String',datestr(dn(min(data.nss1970))),'pos',[0.07 .70 .14 .03],...
    'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12,'Tag','time1b');
set(time1b,'ToolTipString','Start time. Format must be DD-MMM-YYYY HH:MM:SS');
uicontrol('Style','Text','String','start','FontWeight','b',...
    'FontSize',10,'pos',[.02 .705 .05 .02],'units','norm','FontUnits','norm',...
    'back',get(gcf,'Color')*.9);

% radiance or BT button or Rad dif or BT dif
RadOrBT2 = uicontrol('Style','popupmenu','units','norm','pos',[0.05 .58 .12 .04],...
    'Callback','cflag=47;callback','back',[0 .7 0],'String','RAD |BT |RAD dif | BT dif',...
    'fore',[.2 .2 .2],'FontWeight','b','Value',1);

% quit button
quitbutton = uicontrol('Style','PushButton','units','norm','pos',[0.0 0.0 .08 .04],...
    'Callback','cflag=49;callback','back',[.8 0 0],'String','Quit',...
    'fore',[.85 .85 .85],'FontWeight','b');

% clear map
clearbutton1 = uicontrol('Style','PushButton','units','norm','pos',[.10 0.05 .08 .04],...
    'Callback','cflag=48;callback','back',[0 .8 .8],'String','Clear map',...
    'fore',[.2 .2 .2],'FontWeight','b');

% Probe tool
pbutton = uicontrol('Style','Pushbutton','String','Probe Off','Back',get(gcf,'Color')*.8,...
                    'Units','norm','Position',[.01 .94 .21 .04],'FontWeight','b',...
		    'Value',0,'Callback','cflag=50;callback');
uicontrol('Style','frame','Position',[0.01 0.74 .21 .2],...
    'back',get(gcf,'Color')*.9,'units','norm');


% map resolution button
uicontrol('Style','text','String','Map Res.','units','norm',...
    'pos',[.00 0.09 .08 .02],'Callback','cflag=49.5;callback',...
    'back',[.7 .7 .7],'fore',[.2 .2 .2])
mapresbutton = uicontrol('Style','PopUpMenu','units','norm',...
    'pos',[.00 0.05 .08 .04],'Callback','cflag=49.5;callback',...
    'back',[.7 .7 0],'String','low|medium|high',...
    'fore',[.2 .2 .2],'FontWeight','b');
imapres=1;

% color bar limits
cbar_min = uicontrol('Style','edit','pos',[0.33 .01 .08 .03],...
    'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12);
cbar_max = uicontrol('Style','edit','pos',[0.75 .01 .08 .03],...
    'units','norm','back',[.85 .9 .85],'fore','b','FontSize',12);
cmap_mode = uicontrol('Style','PopUp','Units','norm','Position',[.85 .04 .10 .04],...
    'String','Autoscale|Manual','Back',[.8 .8 0],'FontWeight','b',...
    'Callback','cflag=40;callback');
uicontrol('Style','Text','Units','norm','Position',[.85 .085 .10 .02],...
    'String','Colormap Mode','FontWeight','b','Back',get(gcf,'Color'))

% initialize figures
subplot(211)
timeaxis = gca;
ind00 = find(data.sceneMirrorAngle == 0);
timedata=plot(data.timeDECIMAL(ind00),data.Latitude(ind00),'d-','MarkerSize',4);
set(timeaxis,'Position',[.3 .8 .60 .15],'Tag','TIMEAXIS')
xlabel('decimal time')
%xl=get(timeaxis,'XTick');
%xlab=[];for i = 1:length(xl);xlab=[xlab;num2str(fix(xl(i)))];end
%set(timeaxis,'XTickLabel',xlab)
title('time series of nadir views')
ylabel('Latitude')
grid on;axis auto

subplot(212);
mapaxis = gca;

if data.Longitude(1) < 0
   quirkflag = 1;
else 
   quirkflag = 0;
end

if 0
  load latlons
  lat = [lat(1:8892);NaN;lat(8893:28411)];
  lon = [lon(1:8892);NaN;lon(8893:28411)];
  h=plot(lon,lat,'Color',0.5*[0.5 0.8 0.5]);
else
  plot_cst([-inf inf],[-inf inf],'c',2,quirkflag);
end

ylabel('latitude (^o)');xlabel('longitude (^o)')
hold on
ind00 = find(data.sceneMirrorAngle == 0);
indm45 = find(data.sceneMirrorAngle == -45);
indp45 = find(data.sceneMirrorAngle == +45);
plot(data.Longitude(ind00),data.Latitude(ind00),'o-',...
    'Color','r','LineWidth',2,'MarkerSize',3,'Tag','mapdata');
plot(data.Longitude(indm45),data.Latitude(indm45),'o-',...
    'Color','b','LineWidth',2,'MarkerSize',3,'Tag','mapdata');
plot(data.Longitude(indp45),data.Latitude(indp45),'o-',...
    'Color','b','LineWidth',2,'MarkerSize',3,'Tag','mapdata');
h=text(data.Longitude(1),data.Latitude(1),datestr(data.dateNumber(1)));
h=text(data.Longitude(data.nspec),data.Latitude(data.nspec),...
    datestr(data.dateNumber(data.nspec)));
grid on
cbar = colorbar('horiz');set(cbar,'Tag','CBAR',...
    'Position',[.33 .05 .5 .05],'XTick',[],'XTickLabel',[]);
set(mapaxis,'Position',[.27 .18 .67 .55],'Tag','MAPAXIS')

cmap = colormap;

holder2

% button for false color images
uicontrol('Style','PushButton','units','norm','pos',[.10 0.00 .08 .04],...
    'Callback','cflag=48.5;callback','back',[0 .8 0],'String','image',...
    'fore',[.2 .2 .2],'FontWeight','b');


zoom on
help zoom



